<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;

class AlteSalarioRepository {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    
    public function getModalidadeSalarial($nrorg) {
        $sql = <<<SQL
    SELECT
        * 
    FROM
       FPA_TPMODALIDSAL 
    WHERE
       NRORG = :P_NRORG 
       OR NRORG = 0
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }
    
    public function getTipoAlteraSal($nrorg) {
        $sql = <<<SQL
    SELECT
        * 
    FROM
       GPE_TIPOALTERA 
    WHERE
       NRORG = :P_NRORG 
       OR NRORG = 0
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }
    
    public function getUltimoSalario($nrorg,$dtmescompetencia,$nrvinculom) {
        $sql = <<<SQL
   SELECT
       * 
    FROM
       GPE_ALTESALARIO ATS 
    WHERE
       ATS.NRORG = :P_NRORG 
       AND ATS.NRVINCULOM = :P_NRVINCULOM 
       AND ATS.DTALTESALARIO = 
       (
          SELECT
             MAX(DTALTESALARIO) 
          FROM
             GPE_ALTESALARIO 
          WHERE
             DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC) 
             AND NRORG = ATS.NRORG 
             AND NRVINCULOM = ATS.NRVINCULOM 
       )
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg,
                'P_DTMESCOMPETENC'  => $dtmescompetencia,
                'P_NRVINCULOM'      => $nrvinculom
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }

}